<?php

/**
 * liquidacion_provision_total actions.
 *
 * @package    nomina
 * @subpackage liquidacion_provision_total
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class liquidacion_provision_totalActions extends sfActions {

    /**
     * Liquidacion Definitiva
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------* Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");


        /**
         * Abrir nueva conexion con la Base de Datos
         */
        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();

        /*
         * Formato de fecha
         */
        //Sql
        $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD" 
EOD;
        //Ejecutar SQL
        CN_TABLE::executeSQL($sql);
        $arrayConstantes = array();

        try {


            /**
             * Consultar salario minimo
             */
            $salario_minimo = 550000;
            //Sql
            $sql = <<<EOD
(select nvl(valor_mensual, 0) as valor_mensual from no_smdlv where vigencia = extract(year from sysdate))  
EOD;
            //Ejecutar SQL
            $record_smlv = CN_TABLE::executeSQL($sql);

            if (count($record_smlv) > 0) {
                //No se debe redondear - 20130802
//                $salario_minimo = round($record_smlv[0]['valor_mensual'], -3);
                $salario_minimo = round($record_smlv[0]['valor_mensual']);
            }

            /**
             * Cargar tabla constantes
             */
            $text = '$con_';
            //Constantes 
            $sql = <<<EOD
Select cons.*, '$text'|| cons.id_constante as reemplazo from no_constante cons 
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);


            //Agrega a un array todas las constantes
            foreach ($records as $value) {

//                foreach ($value as $key => $value2) {
//                    $this->logMessage($key . " - " . $value2);
//                }

                $arrayConstantes[$value['reemplazo']] = $value;
//                $this->logMessage($value['reemplazo'] . "------------------------" . $arrayConstantes[$value['reemplazo']]);
            }

            /*
             * Anexo de variables del request para reemplazo en constantes
             */
//            $arrayConstantes[''] = '';

            /**
             * Variables de filtro
             */
            //id_periodo
            $id_periodo = $request['id_periodo_filtro'];
            $id_periodo_actual = $request['id_periodo'];
            $progress_key = $request['progress_key'] . $request['username'];

            //id_agrup_concepto
            $id_agrup_concepto = $request['id_agrup_concepto'];

            //Funcionario num_doc
            $num_doc = null;
            $whereFuncionarioNumDoc = "";
            if (isset($request['num_doc'])) {
                $num_doc = $request['num_doc'];
                $whereFuncionarioNumDoc = " AND tab0.num_doc = '" . $request['num_doc'] . "'";
            }
            //Funcionario id_tipo_doc 
            $id_tipo_doc = null;
            $whereFuncionarioTipoDoc = "";
            if (isset($request['id_tipo_doc'])) {
                $id_tipo_doc = $request['id_tipo_doc'];
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            }

            /*
             *  Borrar datos anteriores Periodo-Funcionario
             */
            //Sql
            $sql = <<<EOD
DELETE FROM NO_LIQUIDA_PROVISION tab0 WHERE tab0.id_periodo = $id_periodo 
and tab0.id_agrup_concepto = $id_agrup_concepto     
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
EOD;
            //Ejecutar SQL
            CN_TABLE::executeSQL($sql);

            /*
             * Tomar valores de NO_AJUSTE_NOMINA
             */
//            //Sql
//            $sql = <<<EOD
//Insert into NO_LIQUIDA_PROVISION (ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,ID_PERIODO,VALOR_LIQUIDADO,FECHA_DESDE,FECHA_HASTA,NUM_DIAS) 
//
//select 
//tab0.id_tipo_doc,
//tab0.num_doc,
//tab0.id_concep_nomina,
//tab0.id_periodo,
//tab0.valor_ajuste,
// to_date( '01/' || per.id_meses || '/' || per.id_anhos, 'dd/mm/yyyy')  as fecha_desde,
//TRUNC(LAST_DAY( to_date(per.id_meses || '/' || per.id_anhos, 'mm/yyyy')  )) as fecha_hasta,
//tab0.num_dias
//from no_ajuste_nomina tab0
//join no_periodo per
//on per.id_periodo = tab0.id_periodo 
//WHERE tab0.id_periodo = $id_periodo 
//$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
//EOD;
//            //Ejecutar SQL
//            CN_TABLE::executeSQL($sql);


            /**
             * Funcionarios con novedad de retiro en el mes del periodo filtrado
             * Se verifico validacion cuando es de periodo mes 7 Julio para tomar el mismo año - 20130724
             */
            //Sql
//            $sql = <<<EOD
//select
//nom.id_clase_planta,
//$salario_minimo as salario_minimo,
//1 as tag,
//per.id_anhos as vig_ini,
//1 as per_ini,
//extract(YEAR FROM nom.fecha_retiro) as vig_fin,
//extract(MONTH FROM nom.fecha_retiro) as per_fin, 
//tab0.*,
//nom.fecha_ingreso,
//nom.fecha_termina,
//nom.fecha_retiro,
//per.id_anhos,
//per.id_meses,
//per.id_anhos || '-01-01' as fecha_ini,
//case when 7 > per.id_meses
//then per.id_anhos - 1 else per.id_anhos end  as anho_ini
//from no_novedad_personal tab0
//
//join no_novedades novs
//on novs.id_novedad = tab0.id_novedad
//
//join no_tipo_novedad tipnov
//on tipnov.id_tipo_novedad = novs.id_tipo_novedad
//
//join no_periodo per
//on per.id_periodo = tab0.id_periodo
//
//left join no_nombramiento_v nom
//on tab0.num_doc = nom.num_doc
//and tab0.id_tipo_doc = nom.id_tipo_doc
//--and nom.estado = 1
//
//where 
//tipnov.id_tipo_novedad = 2
//and per.id_meses = (select id_meses from no_periodo where id_periodo = $id_periodo)   
//and per.id_anhos = (select id_anhos from no_periodo where id_periodo = $id_periodo) 
//$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
//and tab0.estado = 1                 
//
//and (nom.estado = 1 or
//  ( nom.estado = 0 
//    and (nom.fecha_retiro
//  between to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy')
//  and trunc(last_day( to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo_actual) ,'dd/mm/yyyy') ))
//  or nom.fecha_retiro = trunc(last_day( to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy') )) + 1 )
//  )
//)
//EOD;

            /*
             * Cargar Periodo-Funcionario-Concepto
             * 
             * Cargar Funcionarios
             * 
             * Para cada persona
             * 
             * Cargar conceptos que apliquen en periodo para la persona, en orden de ejecución
             */
            /*
             * Se modificó la formula de liquidación de Vacaciones,  colocando la condición de Bonificación por servicios.  
             * Por lo tanto se debe verificar que el orden de concpetos para liquidación de la nómina los conceptos 1007, 1008, 1009 y 1010   
             * se liquiden despues del concpeto 1011 - 20130812
             * Se cambia calculo de dias por FECHA_RANGO_SIN_TREINTAYUNO para no tomar los dias 31 en wdiasv - 20130913
             * Tag_retro para cuando es retroactivo, para retencion tiene encuenta todo el mes con lo del retroactivo - 20150610
             * Todos los periodos del año y mes - 20170928
             * Se verifica segnu estado y no fecha_termina - 20210122::LAVILA
             * Incidente #39367, Se aplica fecha de ingreso el campo de solucion con continuidad - 20250210::LAVILA
             */
            //Sql
            $sql = <<<EOD
select distinct
tab.id_clase_planta,
tab.tag,
tab.tg_retro,
tab.vig_ini,
tab.per_ini,
extract(YEAR FROM tab.fecha_termina) as vig_fin,
extract(MONTH FROM tab.fecha_termina) as per_fin, 
tab.fecha_ingreso,
tab.fecha_termina,
tab.fecha_retiro,
tab.id_anhos,
tab.id_anhos || '-01-01' as fecha_ini,
case when 7 > tab.id_meses
then tab.id_anhos - 1 else tab.id_anhos end  as anho_ini,
tab.id_meses,
tab.id_tipo_doc,
tab.num_doc,
sum(tab.dias_liq) as dias_liq, 
tab.wdiasv,
tab.orden,
tab.codigo,
tab.usa_dias_calen,
tab.id_concep_nomina 

from(
                    
        select 
        nombra.id_clase_planta,
        $salario_minimo as salario_minimo,
        1 as tag,
        0 as tg_retro,
        per.id_anhos as vig_ini,
        1 as per_ini,
        per.id_anhos as vig_fin,
        1 as per_fin, 
        case 
        when nombra.solucion_continuidad = 0 then nombra.fecha_ingreso 
        else case when extract(year from nvl((select max(nom.fecha_ingreso) from no_nombramiento nom where nom.id_tipo_doc = 1 and nom.num_doc = TAB0.NUM_DOC and nom.id_nombramiento != nombra.id_nombramiento ),nombra.fecha_ingreso)) = (select id_anhos from no_periodo where id_periodo = $id_periodo)
              then nvl((select max(nom.fecha_ingreso) from no_nombramiento nom where nom.id_tipo_doc = 1 and nom.num_doc = TAB0.NUM_DOC and nom.id_nombramiento != nombra.id_nombramiento ),nombra.fecha_ingreso)
              else TO_DATE( (select ID_ANHOS from NO_PERIODO where ID_PERIODO = $id_periodo) || '-01-01','yyyy-mm-dd') end
        end as fecha_ingreso,
        (SELECT FECHA_FIN FROM NO_PERIODO where ID_PERIODO = $id_periodo) as fecha_termina,
        (SELECT FECHA_FIN FROM NO_PERIODO where ID_PERIODO = $id_periodo) + 1 as fecha_retiro,
        tab0.id_anhos,
        tab0.id_meses,
        tab0.id_tipo_doc,
        tab0.num_doc,
        tab0.num_dias as dias_liq,
        nvl(vac.dias_vac,0) as wdiasv,
        tipcon.orden,
        connom.codigo,
        connom.usa_dias_calen,
        connom.id_concep_nomina
                    
        from no_concepto_periodo tab0

        join no_periodo per
        on per.id_periodo = tab0.periodo

        left join no_nombramiento_v nombra
        on tab0.num_doc = nombra.num_doc
        and tab0.id_tipo_doc = nombra.id_tipo_doc

        join no_concep_nomina connom
        on connom.id_concep_nomina = tab0.id_concep_nomina

        join no_tipo_concepto tipcon
        on tipcon.id_tipo_concepto = connom.id_tipo_concepto

        left join (

            select 
         novvac.id_tipo_doc,                  
         novvac.num_doc,
         nvl(sum(dias_rango_mes(novvac.fecha_ini,novvac.fecha_fin,(select id_meses 
             from no_periodo where id_periodo =  $id_periodo))),0) as dias,
         nvl(sum( novvac.fecha_fin - novvac.fecha_ini + 1),0) as num_dias_vac,
         nvl(sum(FECHA_RANGO_SIN_TREINTAYUNO(novvac.fecha_ini,novvac.fecha_fin)),0) as dias_vac
         from no_novedad_vac novvac
         left join no_tipo_nov_vac tipnov on tipnov.id_tipo_nov_vac = novvac.id_tipo_nov_vac
         where tipnov.tiempo_liqui = 1 and novvac.id_periodo = $id_periodo
         group by novvac.id_tipo_doc, novvac.num_doc

        )vac
        on vac.id_tipo_doc = tab0.id_tipo_doc and vac.num_doc = tab0.num_doc

        join no_estado_func estfunc
        on tab0.id_tipo_doc = estfunc.id_tipo_doc
        and tab0.num_doc = estfunc.num_doc
        and tab0.periodo = estfunc.periodo
        and estfunc.actual = 1

        where 
        tab0.periodo in ( 
            SELECT ID_PERIODO FROM no_periodo where ID_ANHOS = (SELECT ID_ANHOS FROM no_periodo where ID_PERIODO = $id_periodo)
                and ID_MESES = (SELECT ID_MESES FROM no_periodo where ID_PERIODO = $id_periodo)
        )
        $whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
        and tab0.id_concep_nomina = (select id_concep_basica from no_param_concep where id_param_concep = 1)
        and tipcon.id_tipo_concepto != 4
        ---and nombra.fecha_termina is null        
        and (
            nombra.estado = 1 
            or (
                nombra.estado = 0 and nombra.fecha_termina > (select no_periodo.fecha_fin from no_periodo where id_periodo = $id_periodo )  
            )
        )
                    
)tab
                    
group by
tab.id_clase_planta,
tab.tag,
tab.tg_retro,
tab.vig_ini,
tab.per_ini,
tab.vig_fin,
tab.per_fin, 
tab.fecha_ingreso,
tab.fecha_termina,
tab.fecha_retiro,
tab.id_anhos,
tab.id_meses,
tab.id_tipo_doc,
tab.num_doc,
tab.wdiasv,
tab.orden,
tab.codigo,
tab.usa_dias_calen,
tab.id_concep_nomina 
                    
order by 
tab.id_anhos,
tab.id_meses,
tab.id_tipo_doc,
tab.num_doc,
tab.orden,
case 
  when tab.codigo >= 4000  
      then '0000'
  when tab.id_concep_nomina = (select no_param_concep.id_concep_bonif from no_param_concep where no_param_concep.id_param_concep = 1)  
      then '0001'
      else tab.codigo 
  end   
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);

            //Validar si hay funcionarios para liquidación
            if (count($records) > 0) {
                $this->logMessage("[Liquidación Definitiva] Validar si hay funcionarios para liquidación.");

                /*
                 * Obtener concep_periodo por agrupacion - Orden a liquidar
                 */
                $sql = <<<EOD
select 
* 
from no_agrup_deta
where id_agrup_concepto = $id_agrup_concepto
order by 
orden,
id_agrup_deta 
EOD;
                //Ejecutar SQL
                $records_agrup = CN_TABLE::executeSQL($sql);


                /*
                 * Por funcionario 
                 */
                $i = 1;
                $nom_conceptos_a_procesar = count($records);

                // Antes de inicar el proceso largo
                $brecha = 1;
                if ($nom_conceptos_a_procesar > 100)
                    $brecha = $nom_conceptos_a_procesar - (0.99 * $nom_conceptos_a_procesar);

                $this->logMessage("[Liquidación Definitiva] nom_conceptos_a_procesar: " . $nom_conceptos_a_procesar);
                foreach ($records as $value) {

                    // Guardar un valor en el proceso largo
                    if ($i % $brecha == 0) {
                        MemcacheHandler::getInstance()->set($progress_key, round(($i / $nom_conceptos_a_procesar) * 100, 0));
                    }

                    $this->logMessage("[Liquidación Definitiva] Existen liquidaciones.");

                    /*
                     * Datos por record
                     */
                    $num_doc = $value['num_doc'];
                    $id_tipo_doc = $value['id_tipo_doc'];
                    $fecha_ingreso = $value['fecha_ingreso'];
                    $fecha_termina = $value['fecha_termina'];
                    $fecha_retiro = $value['fecha_retiro'];
                    $vig_ini = $value['vig_ini'];
                    $per_ini = $value['per_ini'];
                    $vig_fin = $value['vig_fin'];
                    $per_fin = $value['per_fin'];
                    $id_clase_planta = $value['id_clase_planta'];

                    /*
                     * Calcular los meses a liquidar
                     */
//                    $meses_liq = 0;

                    $anho_ini = $value['id_anhos'];
                    $fecha_ini = $anho_ini . '-07-01';
                    $anho_fin = $anho_ini + 1;
                    $fecha_fin = $anho_fin . '-07-01';
                    $meses_liq = $this->mesesLiquidar($id_periodo, $num_doc, $id_tipo_doc, $fecha_ingreso, $fecha_termina, $value, $fecha_ini, $fecha_fin);
                    $this->logMessage("[Liquidación Definitiva] Meses de Liquidación: " . $meses_liq);
                    if ($meses_liq < 0) {
                        $meses_liq = 0;
                    }

                    /**
                     * Recorrer Agrupaciones
                     */
                    foreach ($records_agrup as $value_agrup) {

                        /*
                         * Variables agrup_concep
                         */
                        $id_concep_nomina = $value_agrup['id_concep_nomina'];
                        $caracter = $value_agrup['tipo_valor'];

                        /*
                         * Calcular los dias a liquidar
                         */
                        $dias_liq_array = $this->diasLiquidar($id_periodo, $num_doc, $id_tipo_doc, $fecha_ingreso, $fecha_termina, $value, $id_concep_nomina);

                        $dias_liq = $dias_liq_array['num_dias'];
                        $dias_liq_base = $dias_liq_array['num_dias_base'];
                        $dias_otra_ent = $dias_liq_array['dias_otra_entidad'];

                        $this->logMessage("[Liquidación Provision total] Dias de Liquidación: " . $dias_liq);


                        /*
                         * Tag_retro para cuando es retroactivo, para retencion tiene encuenta todo el mes con lo del retroactivo - 20150610
                         * Incidente #6468 <-> Se agrega valor_bonif - 20170613
                         */
                        $sql = <<<EOD
select
nvl((select valor_uvt from ts_uvt where vigencia = (select no_periodo.id_anhos from no_periodo where id_periodo = $id_periodo)) , 1) as valor_uvt,  
nvl((select valor_fijo from no_concep_ab where id_concep_nomina in (select no_param_concep.id_concep_bonif from no_param_concep where no_param_concep.id_param_concep = 1)) , 1) as valor_bonif,                      
$id_clase_planta as id_clase_planta, 
$salario_minimo as salario_minimo,
1 as tag,
0 as tg_retro,
0 as promedio,
$vig_ini as vig_ini,
$per_ini as per_ini,
$vig_fin as vig_fin,
$per_fin as per_fin,
$meses_liq as meses_liq,
$dias_liq as dias_liq,
$dias_otra_ent as dias_otra_ent,
0 as dias_ausenc,
'$caracter' as caracter,
nvl('$fecha_ingreso', '') as fecha_ingreso,
nvl('$fecha_termina', '') as fecha_termina,
nvl('$fecha_retiro', '') as fecha_retiro,
$dias_liq as num_dias,
$dias_liq_base as num_dias_base,
null as porcentaje,
$num_doc as num_doc,
$id_tipo_doc as id_tipo_doc,
$id_periodo as id_periodo,
$id_periodo as periodo,
$id_concep_nomina as id_concep_nomina
from dual     
EOD;
                        //Ejecutar SQL
                        $recordsLiq = CN_TABLE::executeSQL($sql);

                        /*
                         * Validar registro
                         */
                        if (count($recordsLiq) > 0) {

                            //Liquidar concepto
                            $record_liq = $recordsLiq[0];
                            $this->liquidar($id_periodo, $num_doc, $id_tipo_doc, $id_concep_nomina, $record_liq, $arrayConstantes, $id_agrup_concepto);
                        } else {
                            /*
                             * Mensaje de error
                             */
                            $mensajeError = "No hay registro para liquidación definitiva. Concepto: " . $id_concep_nomina;

//                            $this->status = 1;
//                            $this->list_data = array();
//                            $this->mensajeError = $mensajeError;
                            $this->logMessage("[Liquidación Definitiva] " . $mensajeError);
                        }
                    }
//                    die();
                    $i++;


                    /*
                     * Solo retefunte
                     * Inicio del proceso de calculo de Retencion en la fuente concepto 2001
                     * Tag_retro para cuando es retroactivo, para retencion tiene encuenta todo el mes con lo del retroactivo - 20150610
                     * Incidente #6468 <-> Se agrega valor_bonif - 20170613
                     */
                    //Sql
                    $sql = <<<EOD
select
nvl((select valor_uvt from ts_uvt where vigencia = (select no_periodo.id_anhos from no_periodo where id_periodo = $id_periodo)) , 1) as valor_uvt,  
nvl((select valor_fijo from no_concep_ab where id_concep_nomina in (select no_param_concep.id_concep_bonif from no_param_concep where no_param_concep.id_param_concep = 1)) , 1) as valor_bonif,                      
$id_clase_planta as id_clase_planta, 
$salario_minimo as salario_minimo,
1 as tag,
0 as tg_retro,
0 as meses_liq,
'O' as caracter, 
0 as num_dias, 
0 as num_dias_base,
0 as dias_liq,
0 as dias_otra_ent,
$id_periodo as id_periodo,
$id_periodo as periodo,
tab0.*, 
tab0.fecha_desde as fecha_ingreso,
tab0.fecha_hasta as fecha_termina,
tab0.fecha_hasta as fecha_retiro
from no_concepto_func tab0
WHERE 1 = 1 
AND tab0.num_doc = '$num_doc'
AND tab0.id_tipo_doc = $id_tipo_doc 
and tab0.id_concep_nomina = (select id_concep_rete from no_param_concep where id_param_concep = 1)
and tab0.estado = 0
and tab0.actual = 1
order by 
tab0.id_tipo_doc,
tab0.num_doc 
EOD;
                    //Ejecutar SQL
                    $records = CN_TABLE::executeSQL($sql);


                    /*
                     * Recorre los registros de funcionario - concepto nomina
                     * para ser liquidados
                     */
//                    foreach ($records as $value) {
//                        $this->logMessage("[Liquidación Definitiva] Existen liquidaciones.");
//
//                        $id_periodo = $value['periodo'];
//                        $num_doc = $value['num_doc'];
//                        $id_tipo_doc = $value['id_tipo_doc'];
//                        $id_concep_nomina = $value['id_concep_nomina'];
//
//                        /*
//                         * Liquidar periodo-funcionario-concepto nomina
//                         */
//                        $this->liquidar($id_periodo, $num_doc, $id_tipo_doc, $id_concep_nomina, $value, $arrayConstantes, $id_agrup_concepto);
//                    }
                }
                /*
                 * Memcache al 100 porciento
                 */
                MemcacheHandler::getInstance()->set($progress_key, 100);

                /*
                 * COMMIT DE TODAS LAS TRANSACCIONES
                 */
                $this->conn->commit();
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage("[Liquidación Definitiva] Liquidación definitiva exitosa.");
            } else {
                MemcacheHandler::getInstance()->set($progress_key, 100);

                /**
                 * ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                 */
                $this->conn->rollback();

                /*
                 * Mensaje de error
                 */
                $mensajeError = "No hay funcionarios para liquidación definitiva.";

                $this->status = 1;
                $this->list_data = array();
                $this->mensajeError = $mensajeError;
                $this->logMessage("[Liquidación Definitiva] " . $mensajeError);
            }
        } catch (Exception $e) {
            MemcacheHandler::getInstance()->set($progress_key, 100);

            /**
             * ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
             */
            $this->conn->rollback();

            /**
             * Respuesta del servicio
             */
            $this->status = 1;
            $this->mensajeError = "[Liquidación Definitiva] Ocurrio un error: " . $e->getMessage();
            $this->list_data = array();
            $this->logMessage("[Liquidación Definitiva] ERROR!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Calcular los meses a liquidar
     * @param type $id_periodo
     * @param type $num_doc
     * @param type $id_tipo_doc
     * @param type $fecha_ingreso
     * @param type $fecha_termina
     * @param type $record
     */
    private function mesesLiquidar($id_periodo, $num_doc, $id_tipo_doc, $fecha_ingreso, $fecha_termina, $record, $fecha_ini, $fecha_fin) {
        /*
         * Variables de calculo
         */
        $meses = 0;
        $dias_otra_entidad = 0;
        $dias_otra_entidad_liq = 0;
        $dias_ausenc = 0;
        $meses_otra_entidad = 0;



        /**
         * Calculo dias certif otra entidad - 20140610
         */
        //Sql
        $sql = <<<EOD
select 
case when FECHA_DESDE < TO_DATE('$fecha_ini','yyyy-mm-dd') then TO_DATE('$fecha_ini','yyyy-mm-dd') else FECHA_DESDE end as FECHA_INI,
case when FECHA_HASTA > TO_DATE('$fecha_fin','yyyy-mm-dd') then TO_DATE('$fecha_fin','yyyy-mm-dd') else FECHA_HASTA end as FECHA_fin,
case when FECHA_HASTA > TO_DATE('$fecha_fin','yyyy-mm-dd') then TO_DATE('$fecha_fin','yyyy-mm-dd') else FECHA_HASTA end 
- 
case when FECHA_DESDE < TO_DATE('$fecha_ini','yyyy-mm-dd') then TO_DATE('$fecha_ini','yyyy-mm-dd') else FECHA_DESDE end as  DIAS, 

ID_CERTIF_OTRA_ENTIDAD,
ID_TIPO_DOC,
NUM_DOC,
NUM_DOC_SOP,
FECHA_SOPORTE,
OBSERVACIONES,
FECHA_DESDE,
FECHA_HASTA,
NUM_DIAS,
aplica_liquidacion

from NO_CERTIF_OTRA_ENTIDAD

where
(
    FECHA_DESDE between TO_DATE('$fecha_ini','yyyy-mm-dd') and TO_DATE('$fecha_fin','yyyy-mm-dd')
    or 
    FECHA_HASTA between to_date('$fecha_ini','yyyy-mm-dd') and to_date('$fecha_fin','yyyy-mm-dd')
)               
AND num_doc = '$num_doc'
AND id_tipo_doc = $id_tipo_doc
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        foreach ($records as $key => $value) {

            $fecha_ini_otra = $value['fecha_ini'];
            $fecha_fin_otra = $value['fecha_fin'];
            $aplica_liq = $value['aplica_liquidacion'];

            if ($aplica_liq == 1) {
                $dias_otra_entidad_liq += CN_TABLE::diasEntreFechas($fecha_ini_otra, $fecha_fin_otra, false);
            }
            $dias_otra_entidad += CN_TABLE::diasEntreFechas($fecha_ini_otra, $fecha_fin_otra, false);
        }

        $this->logMessage("[Liquidación Agrupación] Dias de otra entidad: " . $dias_otra_entidad);
        $meses_otra_entidad = ($dias_otra_entidad * 12) / 360;
        $this->logMessage("[Liquidación Agrupación] Meses de otra entidad: " . $meses_otra_entidad);



        /**
         * Recorrer cada mes desde el ingreso para verificar kardex
         * verificar ingreso y retiro -20140610
         */
        $anho_ini = $record['anho_ini'];
        $fecha_ini = $anho_ini . '-07-01';
        $date1 = new DateTime($fecha_ini);
        $date2 = new DateTime($fecha_ingreso);
        $this->logMessage("[CN_TABLE] fecha_ini: " . $fecha_ini . ' - fecha_ingreso: ' . $fecha_ingreso);
        if ($date2 > $date1) {
            $fecha_ingreso_ka = $fecha_ingreso;
        } else {
            $fecha_ingreso_ka = $fecha_ini;
        }
        $fecha_termina_ka = $fecha_termina;

        //Dividir fecha formato yyyy-mm-dd
        $fecha_ingreso_ka = explode('-', $fecha_ingreso_ka);
        $fecha_termina_ka = explode('-', $fecha_termina_ka);

        $anho_mes_ini = $fecha_ingreso_ka[0] . str_pad($fecha_ingreso_ka[1], 2, '0', STR_PAD_LEFT);
        $anho_mes_fin = $fecha_termina_ka[0] . str_pad($fecha_termina_ka[1], 2, '0', STR_PAD_LEFT);

        $anho_mes_ini = $anho_mes_ini * 1;
        $anho_mes_fin = $anho_mes_fin * 1;
        $this->logMessage("[CN_TABLE] anho_mes_ini: " . $anho_mes_ini . ' - anho_mes_fin: ' . $anho_mes_fin);

        $dia_ini = $fecha_ingreso_ka[2];
        $mes_ini = $fecha_ingreso_ka[1];
        $anho_ini = $fecha_ingreso_ka[0];
        $dia_fin = $fecha_termina_ka[2];
        $mes_fin = $fecha_termina_ka[1];

        do {

            /*
             * Validar mes completo
             */
            if ($anho_mes_ini <= $anho_mes_fin && $dia_ini == 1) {
                $dias_ausenc = $dias_ausenc + $this->tieneNovKa($id_tipo_doc, $num_doc, $anho_ini, $mes_ini);
            }

            if ($anho_mes_ini > 220001) {
                $this->logMessage("[CN_TABLE] Supero mes 220001.");
                $dias_ausenc = 0;
                $anho_mes_ini = $anho_mes_fin + 1;
            }

            $fecha_ingreso_ka = CN_TABLE::fechaSiguiente(substr($anho_mes_ini, 0, 4), substr($anho_mes_ini, 4, 2));
            $anho_mes_ini = $fecha_ingreso_ka['id_anhos'] . str_pad($fecha_ingreso_ka['id_meses'], 2, '0', STR_PAD_LEFT);
            $anho_mes_ini = $anho_mes_ini * 1;
            $dia_ini = 1;

            $anho_ini = $fecha_ingreso_ka['id_anhos'];
            $mes_ini = $fecha_ingreso_ka['id_meses'];

            $this->logMessage("[CN_TABLE] anho_mes_ini: " . $anho_mes_ini);
        } while ($anho_mes_ini <= $anho_mes_fin);


        $this->logMessage("[Liquidación Agrupación] Dias de ausencias-meses: " . $dias_ausenc);



        /*
         * Prima servicios proporcional - Julio 1 anterior a la fecha de retiro y hasta la misma fecha de retiro
         */
        $anho_ini = $record['anho_ini'];
        $fecha_ini = $anho_ini . '-07-01';

        $date1 = new DateTime($fecha_ini);
        $date2 = new DateTime($fecha_ingreso);

        if ($date2 > $date1) {
            $meses = CN_TABLE::mesesEntreFechas($fecha_ingreso, $fecha_termina, false);
        } else {
            $meses = CN_TABLE::mesesEntreFechas($fecha_ini, $fecha_termina, false);
        }

        /**
         * Calculo de meses
         */
        $this->logMessage("[Liquidación Definitiva] Meses liquidacion: " . $meses);

        /**
         * return meses
         */
        return $meses + $meses_otra_entidad - $dias_ausenc;
    }

    /**
     * Calcular los meses a liquidar
     * @param type $id_periodo
     * @param type $num_doc
     * @param type $id_tipo_doc
     * @param type $fecha_ingreso
     * @param type $fecha_termina
     * @param type $record
     */
    private function mesesLiquidar2($id_periodo, $num_doc, $id_tipo_doc, $fecha_ingreso, $fecha_termina, $record) {
        /*
         * Variables de calculo
         */
        $meses = 0;

        /*
         * Prima servicios proporcional - Julio 1 anterior a la fecha de retiro y hasta la misma fecha de retiro
         */
        $anho_ini = $record['anho_ini'];
        $fecha_ini = $anho_ini . '-07-01';

        $date1 = new DateTime($fecha_ini);
        $date2 = new DateTime($fecha_ingreso);

        if ($date2 > $date1) {
            $meses = CN_TABLE::mesesEntreFechas($fecha_ingreso, $fecha_termina, false);
        } else {
            $meses = CN_TABLE::mesesEntreFechas($fecha_ini, $fecha_termina, false);
        }

        /**
         * Calculo de meses
         */
//        $this->logMessage("[Liquidación Definitiva] Meses liquidacion: " . $meses);
        return $meses;
    }

    /**
     * Calcular los dias a liquidar (ausencias no afectan antiguedad) 
     * @param type $id_periodo
     * @param type $num_doc
     * @param type $id_tipo_doc
     * @param type $fecha_ingreso
     * @param type $fecha_termina
     * @param type $record
     * @param type $id_concep_nomina
     * @return int
     */
    private function diasLiquidar($id_periodo, $num_doc, $id_tipo_doc, $fecha_ingreso, $fecha_termina, $record, $id_concep_nomina) {

        /*
         * Variables de calculo
         */
        $dias_causa_ult = 0; // - 202010202::LAVILA
        $dias = 0;
        $dias_base = 0;
        $dias_array = array();
        $dias_kardex = 0;
        $dias_vac = 0;
        $dias_otra_entidad = 0;
        $dias_otra_entidad_liq = 0;
        $dias_otra_entidad_extra = 0; //Para forzar el calculo de 1016 - 20181116

        $fecha_ini_ka = $fecha_ingreso;
        $fecha_fin_ka = $fecha_termina;
        $fecha_retiro = $record['fecha_retiro'];
        $per_fin = $record['per_fin'];

        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        foreach ($array as $routeName => $routeData) {
            //echo $routeName . "\n";
            if ('entidad_cliente' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $entidadCliente = $value;
                    }
                }
            }
            $int++;
        }

        $num_dias_vac = 15;
        $id_concep_interes_ces = 0; //Para CEV pub concepto de interes para los dias igual que cesantias - 20210121::LAVILA
        if ($entidadCliente == 8) {
            $id_concep_interes_ces = 18;
        }
        if ($entidadCliente == 9) {
            $num_dias_vac = 25; //dias cev publica - 20191126
        }

        /*
         * Calculo de dias por concepto
         */
        //Vacaciones proporcional - Tabla de causacion vacaciones
        if ($id_concep_nomina == 7 || $id_concep_nomina == 8 || $id_concep_nomina == 9 || $id_concep_nomina == 10) {
            /*
             * Calculo de dias de ausencias
             */
            //Sql
            $sql = <<<EOD
select * from no_causa_vacac  
where 
num_doc =  '$num_doc'  and  id_tipo_doc = $id_tipo_doc 
and to_date('$fecha_termina','yyyy-mm-dd') between fecha_ini and fecha_fin 
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);

            if (count($records) > 0) {

                //Consulta para dias de otros periodos de vacaciones no tomados - 20130620
                $id_causa_vacac = $records[0]['id_causa_vacac'];
                $dias_causa_ult = $records[0]['dias_disfrutados'];

                //Sql
                $sql = <<<EOD
select sum(nvl(SALDOS_DIAS,0)) as saldos_dias 
from no_causa_vacac  
where 
num_doc =  '$num_doc'  and  id_tipo_doc = $id_tipo_doc 
and ID_CAUSA_VACAC != $id_causa_vacac
--and TO_DATE('$fecha_termina','yyyy-mm-dd') <= FECHA_FIN 
and FECHA_INI <= TO_DATE('$fecha_termina','yyyy-mm-dd')
EOD;
                //Ejecutar SQL
                $records_vac = CN_TABLE::executeSQL($sql);

                $dias_vac = $records_vac[0]['saldos_dias'] * 360 / $num_dias_vac;
                $this->logMessage($records_vac[0]['saldos_dias'] . "[Liquidación Definitiva] dias_vac: " . $dias_vac);

                $fecha_ini = $records[0]['fecha_ini'];
                $fecha_fin = $fecha_termina;

                $dias = CN_TABLE::diasEntreFechas($fecha_ini, $fecha_fin, false);

                //Se toman dias de la tabla de nombramientos que posee hasta el dia que trabaja en fecha_termina
                $dias = $dias + $dias_vac;

                /**
                 * Se toma para novedad kardex desde Enero 1 - 20200113
                 */
                $anho_ini = $record['anho_ini'];
                $fecha_ini = $anho_ini . '-01-01';

                $date1 = new DateTime($fecha_ini);
                $date2 = new DateTime($fecha_ingreso);

                if ($date2 > $date1) {
                    $fecha_ini_ka = $fecha_ingreso;
                } else {
                    $fecha_ini_ka = $fecha_ini;
                }
            }
        }
        //Prima servicios proporcional - Julio 1 anterior a la fecha de retiro y hasta la misma fecha de retiro
        elseif ($id_concep_nomina == 16 || $id_concep_nomina == 19) {

            $anho_ini = $record['anho_ini'];
            $fecha_ini = $anho_ini . '-07-01';

            $date1 = new DateTime($fecha_ini);
            $date2 = new DateTime($fecha_ingreso);
            $date4 = new DateTime($fecha_termina);

            if ($date2 > $date1) {
                $fecha_ini_ka = $fecha_ingreso;
                if ($date2 <= $date4) { //Se valida que la fecha de terminacion no sea menor - 20140722
                    $dias = CN_TABLE::diasEntreFechas($fecha_ingreso, $fecha_termina, false);
                }
            } else {
                $fecha_ini_ka = $fecha_ini;
                if ($date1 <= $date4) { //Se valida que la fecha de terminacion no sea menor - 20140722
                    $dias = CN_TABLE::diasEntreFechas($fecha_ini, $fecha_termina, false);
                }
            }
            //Se toman dias de la tabla de nombramientos que posee hasta el dia que trabaja en fecha_termina
            $dias = $dias;
            $dias_otra_entidad_extra = 180; //Para forzar liquidacion de concepto 1016 - 20181116

            /*
             * Se añaden dias desde que ingresa antes de Julio 1 del anho anterior - 20130725
             * Se quitan los dias, esta inflando los dias de la validacion del calculo de la formula - 20140723
             */
            if ($date2 < $date1) {
                //$dias_otra_entidad += CN_TABLE::diasEntreFechas($fecha_ingreso, $fecha_ini, false);
            }
        }
        //Prima de navidad proporcional - Enero 1 a la fecha de retiro
        elseif ($id_concep_nomina == 17 || $id_concep_nomina == 20 || $id_concep_nomina == $id_concep_interes_ces) {

            $fecha_ini = $record['fecha_ini'];

            $date1 = new DateTime($fecha_ini);
            $date2 = new DateTime($fecha_ingreso);
            //fecha_terminacion
            $date3 = new DateTime($fecha_termina);

            $this->logMessage("[Liquidación Definitiva] Prima de navidad proporcional - Enero 1 a la fecha de retiro." . $fecha_ini . " - " . $fecha_termina);

            /*
             * Validar que la fecha de terminacion sea mayor a la fecha inicial
             */
            if ($date3 >= $date1) {

                /*
                 * Si la fecha de ingreso del funcionario es posterior a la fecha 1 de enero del mismo anho, 
                 * debe tomar solo desde la fecha de ingreso del funcionario
                 */
                if ($date2 > $date1) {
                    $fecha_ini_ka = $fecha_ingreso;
                    $dias = CN_TABLE::diasEntreFechas($fecha_ingreso, $fecha_termina, false);
                } else {
                    $fecha_ini_ka = $fecha_ini;
                    $dias = CN_TABLE::diasEntreFechas($fecha_ini, $fecha_termina, false);
                }
            } else {
                $dias = 0;
            }


            //Dias de proporcionalidad bonificacion por servicios - 20140224
            $dias = $dias;
        }
        //Bonificacion por servicios
        elseif ($id_concep_nomina == 11) {

            /*
             * Registro ultimo de bonificacion
             */
            //Sql
            $sql = <<<EOD
select * from no_bonifica_servicios
where 
num_doc =  '$num_doc'  and  id_tipo_doc = $id_tipo_doc
and to_date('$fecha_termina','yyyy-mm-dd') between fecha_ingresa and fecha_bonifica
order by fecha_bonifica desc 
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);
            if (count($records) > 0) {

                //Consulta para dias de otros periodos de vacaciones no tomados - 20130620
                $fecha_ingresa = $records[0]['fecha_ingresa'];

                $date1 = new DateTime($fecha_ingresa);
                $date2 = new DateTime($fecha_termina);

                if ($date2 > $date1) {
                    $dias = CN_TABLE::diasEntreFechas($fecha_ingresa, $fecha_termina, false);
                }

                $dias = $dias;
            }
        }
        //Liquidar 5043	PROVISION BONIFICACION DE DIRECCION TOTAL para SGC, falta que sea parametrizable el concepto - 20240322::LAVILA
        elseif ($id_concep_nomina == 2048) {
            $this->logMessage("[Liquidación Definitiva] Liquidar 5043-PROVISION BONIFICACION DE DIRECCION TOTAL para SGC.");

            if ($per_fin < 7) {

                $fecha_ini = $record['fecha_ini'];

                $date1 = new DateTime($fecha_ini);
                $date2 = new DateTime($fecha_ingreso);
                //fecha_terminacion
                $date3 = new DateTime($fecha_termina);

                $this->logMessage("[Liquidación Definitiva] Prima de navidad proporcional - Enero 1 a la fecha de retiro." . $fecha_ini . " - " . $fecha_termina);

                /*
                 * Validar que la fecha de terminacion sea mayor a la fecha inicial
                 */
                if ($date3 >= $date1) {

                    /*
                     * Si la fecha de ingreso del funcionario es posterior a la fecha 1 de enero del mismo anho, 
                     * debe tomar solo desde la fecha de ingreso del funcionario
                     */
                    if ($date2 > $date1) {
                        $fecha_ini_ka = $fecha_ingreso;
                        $dias = CN_TABLE::diasEntreFechas($fecha_ingreso, $fecha_termina, false);
                    } else {
                        $fecha_ini_ka = $fecha_ini;
                        $dias = CN_TABLE::diasEntreFechas($fecha_ini, $fecha_termina, false);
                    }
                } else {
                    $dias = 0;
                }


                //Dias de proporcionalidad bonificacion por servicios - 20140224
                $dias = $dias;
            } else {
                $anho_ini = $record['anho_ini'];
                $fecha_ini = $anho_ini . '-07-01';

                $date1 = new DateTime($fecha_ini);
                $date2 = new DateTime($fecha_ingreso);
                //fecha_terminacion
                $date4 = new DateTime($fecha_termina);

                if ($date2 > $date1) {
                    $fecha_ini_ka = $fecha_ingreso;
                    if ($date2 <= $date4) { //Se valida que la fecha de terminacion no sea menor - 20140722
                        $dias = CN_TABLE::diasEntreFechas($fecha_ingreso, $fecha_termina, false);
                    }
                } else {
                    $fecha_ini_ka = $fecha_ini;
                    if ($date1 <= $date4) { //Se valida que la fecha de terminacion no sea menor - 20140722
                        $dias = CN_TABLE::diasEntreFechas($fecha_ini, $fecha_termina, false);
                    }
                }
                //Se toman dias de la tabla de nombramientos que posee hasta el dia que trabaja en fecha_termina
                $dias = $dias;
            }
        } else {
            $this->logMessage("[Liquidación Definitiva] Id de concepto sin identificar.");
//            $dias = 360;
        }

        $fecha_ini = $fecha_ingreso;
        $fecha_fin = $fecha_termina;

        /**
         * Calculo dias certif otra entidad - 20130702
         */
        //Sql
        $sql = <<<EOD
select 
case when FECHA_DESDE < TO_DATE('$fecha_ini','yyyy-mm-dd') then TO_DATE('$fecha_ini','yyyy-mm-dd') else FECHA_DESDE end as FECHA_INI,
case when FECHA_HASTA > TO_DATE('$fecha_fin','yyyy-mm-dd') then TO_DATE('$fecha_fin','yyyy-mm-dd') else FECHA_HASTA end as FECHA_fin,
case when FECHA_HASTA > TO_DATE('$fecha_fin','yyyy-mm-dd') then TO_DATE('$fecha_fin','yyyy-mm-dd') else FECHA_HASTA end 
- 
case when FECHA_DESDE < TO_DATE('$fecha_ini','yyyy-mm-dd') then TO_DATE('$fecha_ini','yyyy-mm-dd') else FECHA_DESDE end as  DIAS, 

ID_CERTIF_OTRA_ENTIDAD,
ID_TIPO_DOC,
NUM_DOC,
NUM_DOC_SOP,
FECHA_SOPORTE,
OBSERVACIONES,
FECHA_DESDE,
FECHA_HASTA,
NUM_DIAS,
aplica_liquidacion

from NO_CERTIF_OTRA_ENTIDAD

where
(
    FECHA_DESDE between TO_DATE('$fecha_ini','yyyy-mm-dd') and TO_DATE('$fecha_fin','yyyy-mm-dd')
    or 
    FECHA_HASTA between to_date('$fecha_ini','yyyy-mm-dd') and to_date('$fecha_fin','yyyy-mm-dd')
)               
AND num_doc = '$num_doc'
AND id_tipo_doc = $id_tipo_doc
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        foreach ($records as $key => $value) {

            $fecha_ini_otra = $value['fecha_ini'];
            $fecha_fin_otra = $value['fecha_fin'];
            $aplica_liq = $value['aplica_liquidacion'];

            if ($aplica_liq == 1) {
                $dias_otra_entidad_liq += CN_TABLE::diasEntreFechas($fecha_ini_otra, $fecha_fin_otra, false);
            }
            $dias_otra_entidad += CN_TABLE::diasEntreFechas($fecha_ini_otra, $fecha_fin_otra, false);
        }

        $this->logMessage("[Liquidación Agrupación] Dias de otra entidad y dias desde fecha_ingreso: " . $dias_otra_entidad);


        /*
         * Claculo de dias de novedad de kardex que afectan antiguedad
         */
        /*
         * Se cambio a fechas contando dias habiles - 20130527
         * Se cambia a FECHA_RANGO_SIN_TREINTAYUNO. Si la novedad tiene una fecha de terminación 
         * mayor a la fecha retiro solo debe tener en cuenta hasta la fecha de retiro. - 20130827
         * Se anexa filtro de estado activo - 20131202
         */
        //Sql
        $sql = <<<EOD
select nvl(sum(dias),0) as dias from(
  select 
  dias_habiles_cant( to_date(novka.fecha_ini,'yyyy-mm-dd'), to_date(novka.fecha_fin,'yyyy-mm-dd') ) as dias_hab,
  (to_date(novka.fecha_fin,'yyyy-mm-dd') - to_date(novka.fecha_ini,'yyyy-mm-dd')) + 1  as dias_cal,  
    
   FECHA_RANGO_SIN_TREINTAYUNO(
        case when TO_DATE(NOVKA.FECHA_INI,'yyyy-mm-dd')  < TO_DATE('$fecha_ini_ka','yyyy-mm-dd') 
    then TO_DATE('$fecha_ini_ka','yyyy-mm-dd') else TO_DATE(NOVKA.FECHA_INI,'yyyy-mm-dd') end
    ,
    case when TO_DATE(NOVKA.FECHA_FIN,'yyyy-mm-dd')  > TO_DATE('$fecha_fin_ka','yyyy-mm-dd') 
    then TO_DATE('$fecha_fin_ka','yyyy-mm-dd') else TO_DATE(NOVKA.FECHA_FIN,'yyyy-mm-dd') end
    ) as dias,
                
  novka.* ,
  tipnov.afecta_antigu,
  tipnov.afecta_alimen
  from no_novedad_kardex novka
  join no_tip_nov_ka tipnov 
  on novka.id_tip_nov_ka = tipnov.id_tip_nov_ka
  and tipnov.afecta_antigu = 1 
  where
    (
        novka.fecha_ini between to_date('$fecha_ini_ka','yyyy-mm-dd') and to_date('$fecha_fin_ka','yyyy-mm-dd')
        or novka.fecha_fin between to_date('$fecha_ini_ka','yyyy-mm-dd') and to_date('$fecha_fin_ka','yyyy-mm-dd')
                
        or
        
        TO_DATE('$fecha_ini_ka','yyyy-mm-dd') between novka.fecha_ini and NOVKA.FECHA_FIN
        or 
        TO_DATE('$fecha_ini_ka','yyyy-mm-dd') between novka.fecha_ini and NOVKA.FECHA_FIN
    )
    AND novka.num_doc = '$num_doc'
    AND novka.id_tipo_doc = $id_tipo_doc
    and novka.estado = 1
) 
EOD;
        //Ejecutar SQL
        $recordsKa = CN_TABLE::executeSQL($sql);

        $dias_kardex = $recordsKa[0]['dias'];

        //Restar dias
        //no restar dias de kardex si es concepto 1011, ya que al registrar la novedad kardex este corre los dias de bonificacion - 20140903
        if ($id_concep_nomina != 11) {
            $this->logMessage("[Liquidación Definitiva] Restar dias kardex: " . $dias_kardex);
            $dias_liq = $dias - $dias_kardex;
        } else {
            $dias_liq = $dias;
        }

        /*
         * Calcula de concepto 1008
         */
        if ($id_concep_nomina == 7 || $id_concep_nomina == 8) {
            $this->logMessage("[Liquidación Definitiva] Concepto - Dias liquidacion: " . $dias_liq . " - Num Dias Vac: " . $num_dias_vac);
            $dias_liq = ($dias_liq * $num_dias_vac) / 360; //Dias completos

            /*
             * Se restan dias del periodo segun liquidacion de los dias disfrutados - 20210202::LAVILA
             */
            $dias_liq = $dias_liq - $dias_causa_ult;
            $this->logMessage("[Liquidación Definitiva] Concepto - Dias liquidacion: " . $dias_liq . " - Dias Causa ULT: " . $dias_causa_ult);
            if ($dias_liq < 0) {
                $this->logMessage("[Liquidación Definitiva] Concepto - Dias 0");
                $dias_liq = 0;
            } else {

                $dias_liq_mod = fmod($dias_liq, 1); //Se agrego los dias (decimales) para calculo completo de los dias de vacaciones - 20140424
                //$dias_base = round($dias_liq);
                $dias_base = $dias_liq - $dias_liq_mod; //Se quita redondeo de los dias para tomar dias completos - 20140521

                $this->logMessage("[Liquidación Definitiva] Concepto - Dias liquidacion: " . $dias_liq . " - Dias Base: " . $dias_base . " - Dias Mod: " . $dias_liq_mod);

                //Dias con festivos
                //Empieza a contar desde el siguiente dia habil
                //Sql
                //No aplica para CEV PUB - 20210202::LAVILA
                //Ticket 30546, se coloca para CEV privada - 20220712::LAVILA
                if ($entidadCliente != 9 && $entidadCliente != 8) {
                    $sql = <<<EOD
select 
DIAS_HABILES(TO_DATE('$fecha_termina','yyyy-mm-dd'), 1),
DIAS_HABILES( DIAS_HABILES(TO_DATE('$fecha_termina','yyyy-mm-dd'), 1) , $dias_base - 1),
DIAS_HABILES( DIAS_HABILES(TO_DATE('$fecha_termina','yyyy-mm-dd'), 1) , $dias_base - 1) - DIAS_HABILES(TO_DATE('$fecha_termina','yyyy-mm-dd'), 1) + 1 as dias from DUAL
EOD;
                    //Ejecutar SQL
                    $records = CN_TABLE::executeSQL($sql);
                } else {
                    $records[0]['dias'] = $dias_base;
                }

                $dias_liq = $records[0]['dias'] + round($dias_liq_mod, 2); //redondeo a dos decimales - 20140728 
            }
        }


        /**
         * Calculo de dias
         */
        $this->logMessage("[Liquidación Definitiva] Dias liquidacion: " . $dias_liq . " - Dias Base: " . $dias_base . " - Dias Kardex: " . $dias_kardex);
        $dias_array = array(
            'num_dias' => $dias_liq,
            'dias_otra_entidad' => $dias_otra_entidad - $dias_otra_entidad_liq + $dias_otra_entidad_extra,
            'dias_otra_entidad_liq' => $dias_otra_entidad_liq,
            'num_dias_base' => $dias_base
        );
        return $dias_array;
    }

    /**
     * Procesa la liquidacion para el periodo, funcionario y concepto nomina
     * @param type $id_periodo
     * @param type $num_doc
     * @param type $id_tipo_doc
     * @param type $id_concep_nomina
     * @param type $record_liq
     * @param type $arrayConstantes
     */
    private function liquidar($id_periodo, $num_doc, $id_tipo_doc, $id_concep_nomina, $record_liq, $arrayConstantes, $id_agrup_concepto) {
        $this->logMessage("[Liquidación Definitiva] Liquidar: periodo " . $id_periodo .
                " - funcionario " . $num_doc . " - concepto nomina " . $id_concep_nomina);

        /**
         * Varibles
         */
        $arrayParametros = array();
        $valor_liquidado = 0;
        $fecha_desde = $record_liq['fecha_ingreso'];
        $fecha_hasta = $record_liq['fecha_termina'];
        $fecha_retiro = $record_liq['fecha_retiro'];
        $num_dias = $record_liq['num_dias'];
        $num_dias_base = $record_liq['num_dias_base'];
        $id_clase_planta = $record_liq['id_clase_planta'];

        /*
         * Valor Base y porcentaje
         */
        $porcentaje = 'null';
        $valor_base = 'null';

        /*
         *  Cargar fórmulas por concepto
         */
        //Sql
        $sql = <<<EOD
Select * from no_formula WHERE id_concep_nomina = $id_concep_nomina 
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        /*
         * Valida si posee formula el concepto
         */
        if (count($records) > 0) {
            $this->logMessage("[Liquidación Definitiva] Entro a calcular Formula.");

            foreach ($records as $value) {

                //se adiciona un nuevo campo de formula para completar la retencion que es muy grande el proceso - 20210415::LAVILA
                $formula = $value['formula'] . $value['formula_adic'];
                $this->logMessage("[Liquidación Definitiva] Formula Inicial: " . $formula);


                /*
                 *  Buscar las constantes, variables, fórmulas(parametros) y agrupaciones que use la fórmula
                 */
                //Reemplazo de constantes            
                $formula = $this->reemplazoConstante($formula, $arrayConstantes);
                $this->logMessage("[Liquidación Definitiva] Formula Constante: " . $formula);

                /*
                 * Reemplaza en la consulta los filtros y valores del SQL, que vienen en el record
                 * Ejemplo: select raz_soc from id_cia where id_cia = $id_cia
                 * Reemplaza $id_cia por el valor en el record
                 */
                if ($record_liq['porcentaje'] == '' || $record_liq['porcentaje'] == null) {
                    $record_liq['porcentaje'] = 0;
                }
                $formula = CN_TABLE::reemplazoConsulta($formula, $record_liq);
                $this->logMessage("[Liquidación Definitiva] Formula consulta los filtros: " . $formula);

                /*
                 * Cambio en la formula de A por (C1+C2)
                 */
                $vars = array();

                CN_TABLE::getVarsInFormula($vars, $formula);

//        var_dump($vars);

                foreach ($vars as $var) {
                    if (substr($var, 0, 1) == 'A') {
                        /*
                         * Cambio de A1 por relacion con los conceptos C1
                         * Ejemplo: 'A1' => '0'
                         */
                        $agrup = $this->reemplazoAgrupacion(substr($var, 1));
                        $this->logMessage("[Liquidación Definitiva] Agrupacion: " . $agrup);

                        $formula = str_replace('{' . $var . '}', $agrup, $formula);
                    }
                }
                $this->logMessage("[Liquidación Definitiva] Formula parametrosFormula y reemplazoAgrupacion: " . $formula);


                /*
                 * Parser de la formula para obtener parametros(variables)
                 * Ejemplo: 'A1' => '0',
                 * 'C1' => '0'
                 */
                $arrayParametros = $this->parametrosFormula($formula);


                /*
                 * Obtener resultados de los parametros(variables)
                 * Ejemplo: $arrayParametros = array(
                 * 'C1' => '0',
                 * 'C2' => '0'
                 * );
                 */
                $arrayParametros = $this->resultadoParametros($arrayParametros, $record_liq);


                /*
                 * Reemplazo de parametros(variables) a la formula
                 * Ejemplo: $arrayParametros = array(
                 * 'C1' => '1100',
                 * 'C2' => '55'
                 * );
                 */
                $formula = $this->reemplazoParametros($formula, $arrayParametros);
                $this->logMessage("[Liquidación Definitiva] Formula Final: " . $formula);


                /*
                 * Ejecutar fórmula
                 * Ejemplo: ( 0 == 0 ? {C1} * $porcentaje : false )
                 * Retorna false  si no cumple con la condicion
                 */
                $formula = str_replace('{', ' ', $formula);
                $formula = str_replace('}', ' ', $formula);
                $result = CN_TABLE::aplicarEval($formula);


                /*
                 * No cumple con la condicion
                 */
//                if ($result === false) {
                if ($result == '-9999' || $result == -9999) {
                    $this->logMessage("[Liquidación Definitiva] Formula No cumple con la condicion: " . $formula);
                    $result = 0;
                }


                /*
                 * Acumulan resultados de liquidacion
                 */
                $valor_liquidado += $result;
                /*
                 * Si es por porcentaje
                 */
                if (($record_liq['porcentaje'] != '' || $record_liq['porcentaje'] != null) && $record_liq['porcentaje'] != 0) {
                    /*
                     * Tipo de formula
                     * V - Valor base 
                     * R - Valor restado 
                     * F - Valor de la fórmula (Uso normal)
                     */
                    if ($value['cod_tipo'] == 'V') {
                        $this->logMessage("[Liquidación Definitiva] Formula CodTipo: " . $value['cod_tipo']);

                        /*
                         * Valor Base y porcentaje
                         */
                        $porcentaje = $record_liq['porcentaje'];
                        $valor_base = ($result * 100) / $record_liq['porcentaje'];
                    }
                }
            }
        } else {

            /**
             * Logica de N
             */
            if ($record_liq['caracter'] == 'N') {
                $this->logMessage("[Liquidación Definitiva] Logica de N - Concepto: " . $id_concep_nomina);

                /*
                 * Resta % (se puede para el valor) 
                 */
                //sumar devengados
                //Sql
                $sql = <<<EOD
select 
nvl(sum(liqnom.valor_liquidado),0) as valor_liquidado  
from no_liquida_nomina liqnom
join no_concep_nomina connom
on liqnom.id_concep_nomina = connom.id_concep_nomina
and connom.operador = 1
where
liqnom.id_periodo = $id_periodo
and liqnom.id_tipo_doc = $id_tipo_doc
and liqnom.num_doc = '$num_doc' 
EOD;
                //Ejecutar SQL
                $records_deveng = CN_TABLE::executeSQL($sql);

                if (count($records_deveng) > 0) {

                    $devengado = $records_deveng[0]['valor_liquidado'];

                    //obtener porcentaje de max_ded_noley
                    $devengado_por = ($devengado * $max_ded_noley) / 100;

                    /*
                     * Si es por porcentaje
                     */
                    if ($record_liq['porcentaje'] != '' || $record_liq['porcentaje'] != null) {

                        $valor_logica_n = (0 * $record_liq['porcentaje']) / 100;
                    } else {
                        $valor_logica_n = $record_liq['valor'];
                    }

                    //Validar resta - operar
                    if (($devengado_por - $valor_logica_n - $valor_sumatoria_logica_n) <= 0) {

                        $valor_liquidado = $valor_logica_n;
                        $valor_sumatoria_logica_n += $valor_liquidado;
                    } else {

                        $valor_liquidado = 0;
                    }
                } else {

                    $this->logMessage("[Liquidación Definitiva] No hay valor devengados.");
                    $valor_liquidado = 0;
                }
            } else {
                /*
                 * La liquidación se hacer por 2 espacios temporales:
                 *
                 * - Mensual
                 * En cuyo caso, todos los meses tienen una duración de 30 días
                 * - Por días calendario
                 * En cuyo caso se hace por la cantidad de días especificada en no_concepto_periodo.num_dias
                 * 
                 * Esta especificación, si se hace mensual o usando los días, lo especifica la variable no_concep_nomina.dias_calendario
                 * 
                 * Si se hace una interrupción en un concepto, digamos algún cargo temporal, debe liquidarse el valor del concepto asÍ: 
                 * Ejemplo: $valor = ($valor_liquidado_concepto_mes/30)*$num_dias
                 */

                /*
                 * Si es por porcentaje y diferente de 0
                 */
                if (($record_liq['porcentaje'] != '' || $record_liq['porcentaje'] != null) && $record_liq['porcentaje'] != 0) {
                    $this->logMessage("[Liquidación Definitiva] Calcular porcentaje - " . $record_liq['porcentaje']);


                    //Sql
                    $sql = <<<EOD
select * from no_liquida_nomina 
where id_concep_nomina = (select id_concep_basica from no_param_concep where id_param_concep = 1)
and id_periodo = $id_periodo
and id_tipo_doc = $id_tipo_doc
and num_doc = '$num_doc' 
EOD;
                    //Ejecutar SQL
                    $records = CN_TABLE::executeSQL($sql);

                    if (count($records) <= 0) {
                        $records[0]['valor_liquidado'] = 0;
                    }

                    //Resultado del calculo de porcentaje
                    $result = ($records[0]['valor_liquidado'] * $record_liq['porcentaje']) / 100;

                    /*
                     * Valor Base y porcentaje
                     */
                    $porcentaje = $record_liq['porcentaje'];
                    $valor_base = $records[0]['valor_liquidado'];
                } else {
                    $this->logMessage("[Liquidación Definitiva] Calcular valor - " . $record_liq['valor']);

                    if (!is_null($record_liq['num_dias'])) {

                        /*
                         * usa_dias_calen
                         */
                        if ($record_liq['usa_dias_calen'] == 0) { //Mensual
                            $num_dias = 30;
                            $num_dias = $record_liq['num_dias']; // ? Revisar
                        } else { //Por días calendario
                            $num_dias = $record_liq['num_dias'];
                        }

                        $result = ($record_liq['valor'] / 30) * $num_dias;
                    } else {
                        $num_dias = 'null';
                        $result = $record_liq['valor'];
                    }
                }

                $valor_liquidado += $result;
            }
        }


        //Dias de proporcionalidad bonificacion por servicios - 20140224
        if ($id_concep_nomina == 11) {
            $valor_liquidado = round(($valor_liquidado * $num_dias) / 360);
        }

        /**
         * Registro de liquida nomina por concepto 
         */
        /*
         * Valida creacion de registro
         */
        if ($valor_liquidado > 0) {

            $this->logMessage("[Liquidación Definitiva] El valor liquidado es: " . $valor_liquidado);


            /**
             * SGC: Valida si es retefuente y redondea al mil - 20140320
             */
            $id_concep_nomina_rete = 0;

            //Sql para tomar id de retefuente
            $sql = <<<EOD
select * from no_param_concep where id_param_concep = 1
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);

            if (count($records) > 0) {
                $id_concep_nomina_rete = $records[0]['id_concep_rete'];
            }
            //SGC: Valida si es retefuente y redondea al mil - 20140320
            if ($id_concep_nomina == $id_concep_nomina_rete) {
                $valor_liquidado = round($valor_liquidado, -3);
            }


            /*
             * Crear nueva liquidación
             * 
             * Asignar valores encontrados en persona
             */
            //insert into no_liquida_provision (id_liquida_nomina,id_tipo_doc,num_doc,id_concep_nomina,
            //id_periodo,valor_liquidado,fecha_desde,fecha_hasta,num_dias, valor_base, porcentaje) 
            //values ('9','1','17304849','1','13','257100',to_date('22/11/12','DD/MM/RR'),
            //to_date('22/11/12','DD/MM/RR'),'30');
            //Sql
            $sql = <<<EOD
insert into NO_LIQUIDA_PROVISION (id_tipo_doc, num_doc, id_concep_nomina,
        id_periodo,id_clase_planta,valor_liquidado,id_agrup_concepto,num_dias) 
        values ( $id_tipo_doc, '$num_doc', $id_concep_nomina, 
                    $id_periodo, $id_clase_planta, round($valor_liquidado), $id_agrup_concepto, $num_dias ) 
EOD;
            //Ejecutar SQL
            CN_TABLE::executeSQL($sql);
        }
        /*
         * Valida si es prima_navidad y el valor es negativo - 20131217
         */ elseif ($valor_liquidado < 0) {
            $this->logMessage("[Liquidación] El valor_liquidado es menor a cero.");

            //Valida si es prima_navidad
            if ($id_concep_nomina == 17) {

                $this->logMessage("[Liquidación] Valida si es prima_navidad y el valor es negativo.");

                /*
                 * Crear nueva liquidación
                 * 
                 * Asignar valores encontrados en persona
                 */
                $valor_liquidado = $valor_liquidado * (-1);

                //Sql
                $sql = <<<EOD
insert into NO_LIQUIDA_PROVISION (id_tipo_doc, num_doc, id_concep_nomina,
        id_periodo,id_clase_planta,valor_liquidado,id_agrup_concepto,num_dias) 
        values ( $id_tipo_doc, '$num_doc', (select case when tab0.id_concep_rein is null then tab0.id_concep_nomina 
    else tab0.id_concep_rein end as id_concep_nomina
from no_concep_nomina tab0    
where tab0.id_concep_nomina = $id_concep_nomina), 
                    $id_periodo, $id_clase_planta, round($valor_liquidado, 0), $id_agrup_concepto, $num_dias ) 
EOD;

                //Ejecutar SQL
                CN_TABLE::executeSQL($sql);
            } else {
                $this->logMessage("[Liquidación] No es retefuente. Valores - " . $id_concep_nomina);
            }
        } else {

            $this->logMessage("[Liquidación Definitiva] El valor_liquidado es cero.");
        }
    }

    /**
     * Reemplaza en la formula las constantes por valores de la tabla NO_CONSTANTE
     * Ejemplo: $con_1
     * @param type $formula
     * @param type $arrayConstantes
     */
    private function reemplazoConstante($formula, $arrayConstantes) {

        /*
         * Recorrer array de Constantes
         */
        foreach ($arrayConstantes as $key => $value) {

            $formula = str_replace($key, $value['valor'], $formula);
        }

        return $formula;
    }

    /**
     * Reemplaza los parametros(variables) a la formula
     * Ejemplo: $key: C1 / $value: valor - 2+5
     * @param type $formula
     * @param type $arrayParametros
     */
    private function reemplazoParametros($formula, $arrayParametros) {

        /*
         * Recorrer array de Parametros
         */
        foreach ($arrayParametros as $key => $value) {

            $formula = str_replace('{' . $key . '}', $value, $formula);
        }

        return $formula;
    }

    /**
     * Obtener resultados de los parametros(variables)
     * Ejemplo: 'C1' => '0'
     * @param type $arrayParametros
     * @param type $record_liq
     */
    private function resultadoParametros($arrayParametros, $record_liq) {

        /*
         * Recorrer array de Parametros
         */
        foreach ($arrayParametros as $key => $value) {

            //Sacar caracter y numero(id_concep_nomina) para consulta
            $caracter = substr($key, 0, 1);
            $id_concep_nomina = substr($key, 1);
            $this->logMessage("[Liquidación Definitiva] Caracter: " . $caracter . ", numero: " . $id_concep_nomina);

            /*
             * Obtener consulta por caracter
             */
            //Sql
            $sql = <<<EOD
select * from NO_CONSULTA where caracter = '$caracter' 
EOD;
            //Ejecutar SQL
            $record = CN_TABLE::executeSQL($sql);

            //Validar registros SQL
            if (count($record) > 0) {

                $consulta = $record[0]['consulta'];

                //Reemplazo de id_concep_nomina
                $consulta = str_replace('$id_concep_nomina', $id_concep_nomina, $consulta);

                /*
                 * Reemplaza en la consulta los filtros y valores del SQL, que vienen en el record
                 * Ejemplo: select raz_soc from id_cia where id_cia = $id_cia
                 * Reemplaza $id_cia por el valor en el record
                 */
                $consulta = CN_TABLE::reemplazoConsulta($consulta, $record_liq);

                /*
                 * Ejecutar SQL de consulta
                 */
                //Sql
                $sql = <<<EOD
$consulta  
EOD;
                //Ejecutar SQL
                $record = CN_TABLE::executeSQL($sql);

                //Validar registros SQL
                if (count($record) > 0) {
                    $valor = $record[0]['valor'];
                } else {
                    $valor = 0;
                }
            } else {
                $valor = 0;
            }

            $arrayParametros[$key] = $valor;
        }

        return $arrayParametros;
    }

    /**
     * Parser de la formula para obtener parametros(variables)
     * Ejemplo: 'C1' => '0'
     * @param type $formula
     * @param type $arrayParametros
     */
    private function parametrosFormula($formula) {

        $vars = array();

        CN_TABLE::getVarsInFormula($vars, $formula);

        foreach ($vars as $var) {
            $arrayParametros[$var] = 0;
        }

//        var_dump($arrayParametros);
//        exit();
//        $arrayParametros = array(
//            'C1' => '0',
//            'C2' => '0',
//            'T1' => '0',
//            'A1' => '0'
//        );

        return $arrayParametros;
    }

    /**
     * Reemplaza las agrupaciones por los parametros(variables)
     * Ejemplo: A1 -> (+C1-C2-T1)
     * @param type $id_agrup_var
     */
    private function reemplazoAgrupacion($id_agrup_var) {

        $agrup = '( ';

        /*
         * Ejecutar SQL de agrupciones
         */
        //Sql
        $sql = <<<EOD
select 
agru.*,
agru.tipo_valor as caracter
from
no_agrup_deta agru
where agru.id_agrup_concepto = $id_agrup_var  
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        /*
         * Recorrer registros 
         */
        foreach ($records as $value) {

            $operador = ($value['operador'] == 1 ? '+' : '-');

            //Concatenar todas las agrupaciones
            $agrup .= $operador . '{' . $value['caracter'] . $value['id_concep_nomina'] . '}';
        }

        $agrup .= ' )';

        return $agrup;
    }

    /**
     * Si posee novedad de kardex para el mes y anho - 20140610
     * @param type $anho
     * @param type $mes
     */
    public function tieneNovKa($id_tipo_doc, $num_doc, $anho, $mes) {

        $cant = 0;

        //Sql
        $sql = <<<EOD
select count(num_doc) as cant from(              
  select      
  novka.*,
  tipnov.afecta_antigu,
  tipnov.afecta_alimen
  from no_novedad_kardex novka
  join no_tip_nov_ka tipnov 
  on novka.id_tip_nov_ka = tipnov.id_tip_nov_ka
  and tipnov.afecta_antigu = 1 
  where
    (
        to_date( '01/' || $mes || '/' || $anho, 'dd/mm/yyyy') between novka.fecha_ini and novka.fecha_fin
        or
        TRUNC(LAST_DAY( to_date( $mes || '/' || $anho, 'mm/yyyy')  )) between novka.fecha_ini and novka.fecha_fin
        
        or
        
        novka.fecha_ini between to_date( '01/' || $mes || '/' || $anho, 'dd/mm/yyyy')  
        and TRUNC(LAST_DAY( to_date( $mes || '/' || $anho, 'mm/yyyy')  ))
        or 
        novka.fecha_fin between to_date( '01/' || $mes || '/' || $anho, 'dd/mm/yyyy')  
        and TRUNC(LAST_DAY( to_date( $mes || '/' || $anho, 'mm/yyyy')  ))
        
    )
    AND novka.num_doc = '$num_doc'
    AND novka.id_tipo_doc = $id_tipo_doc
    and novka.estado = 1
)  
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);
        $cant = $records[0]['cant'];

        /*
         * valida que hay novedad de kardex en el mes y anho
         */
        if ($cant > 0) {
            return 1;
        }

        return 0;
    }

}
